<?php
/************************************************************************************************/
/*																								*/
/*									INSCRIPTIONS DES PARTICIPANTS 								*/
/*																								*/
/*																								*/
/************************************************************************************************/
defined( '_JEXEC' ) or die( 'Restricted access' );

/*
 * Make sure the user is authorized to view this page
 */
$user = & JFactory::getUser();

if ( $user->get('gid') < 21 ) {
	$mainframe->redirect( 'index.php', JText::_('ALERTNOTAUTH') );
}

require_once( "includes/heracles_fonctions.php" ); 

// LUTTEUR
include( "components/com_inscriptions/view/lutteur.html.php" ); 
include( "components/com_inscriptions/controller/lutteur.php" ); 

// DELEGATION
include( "components/com_inscriptions/view/delegation.html.php" ); 
include( "components/com_inscriptions/controller/delegation.php" ); 

// ARBITRE
include( "components/com_inscriptions/view/arbitre.html.php" ); 
include( "components/com_inscriptions/controller/arbitre.php" ); 

// AUTRE
include( "components/com_inscriptions/view/autre.html.php" ); 
include( "components/com_inscriptions/controller/autre.php" ); 

$task			= JRequest::getCmd('task');
$section		= JRequest::getCmd('section');
$categorie		= JRequest::getCmd('categorie');
$id 			= JRequest::getVar('id', 0, 'get', 'int');
$file			= JRequest::getVar('photo_lutteur', '');
$cid 			= JRequest::getVar('cid', array(0), 'request', 'array');
$photo			= JRequest::getVar('photo_lutteur[]', array(0), 'get', 'array');
$option			= JRequest::getCmd('option');
JArrayHelper::toInteger($cid, array(0));




switch ($categorie) {

	// PARTIE ENTRAINEUR
	case "entraineur" :
		switch ($task) {
		
			case "add" :
				entraineur_nouveau();
			break;
				
			case "save" :
				entraineur_save($photo);
			break;		
			
			case "remove" :
				entraineur_del($cid);
			break;		
			
			case "edit" :
				entraineur_edit($cid);
			break;			
			
			default:
				entraineur_liste($option);
			break;
		}
	break;

	// PARTIE ARBITRE
	case "arbitre" :
		switch ($task) {
		
			case "add" :
				switch ($section) {
					case "arbitre_nouveau" :
						arbitre_nouveau();
					break;
					
					default:
						arbitre_exist();
					break;
				}
			break;
				
			case "save" :
				arbitre_save($photo);
			break;		
			
			case "remove" :
				arbitre_del($cid);
			break;		
			
			case "edit" :
				arbitre_edit($cid);
			break;			
			
			default:
				arbitre_liste($option);
			break;
		}
	break;
	
	// PARTIE AUTRE
	case "autre" :
		switch ($task) {
		
			case "add" :

				autre_nouveau();
			break;
				
			case "save" :
				autre_save($photo);
			break;		
			
			case "remove" :
				autre_del($cid);
			break;		
			
			case "edit" :
				autre_edit($cid);
			break;			
			
			default:				

				autre_liste($option);
			break;
		}
	break;
			
	// PARTIE PAR DEFAUT LUTTEUR
	default :
		switch ($task) {
		
			case "add" :
				switch ($section) {
					case "lutteur_nouveau" :
						lutteur_nouveau();
					break;
					
					default:
						lutteur_exist();
					break;
				}
		
			break;
				
			case "publish_part" :
				publierTaxe_part($option, '1', $cid);
			break;		
			
			case "unpublish_part" :
				publierTaxe_part($option, '0', $cid);
			break;		
			
			case "publish_eng" :
				publierTaxe_eng($option, '1', $cid);
			break;		
			
			case "unpublish_eng" :
				publierTaxe_eng($option, '0', $cid);
			break;	
			
			case "save" :
				lutteur_save($photo);
			break;		
			
			case "remove" :
				lutteur_del($cid);
			break;		
			
			case "edit" :
				lutteur_edit($cid);
			break;			
			
			default:
				lutteur_liste($option);
			break;
		}
	break;
}



?>
