<?php

/* création d'une classe Tree générique */
class CTree
{
	var $pere=null;
	var $gauche=null;
	var $droit=null;
	var $data=null;
	
	function CTree($donnee = null)
	{
		$this->data=$donnee;
                return $this;
	}
	function setDroit($pt)
	{
		$this->droit=& $pt;
		$pt->pere=& $this;
	}
	function setGauche($pt)
	{
		$this->gauche=& $pt;
		$pt->pere=& $this;

	}
	function setData($donnee)
	{
		$this->data=$donnee;
		if(method_exists($donnee,'attacherArbre'))
		{
			$donnee->attacherArbre($this);
		}
	}
	function hauteur()
	{
		if($this->pere==null) return 1;
		else return $this->pere->hauteur()+1;
	}
	
	function profondeur()
	{
		$ret1 =0;
		$ret2= 0;
		if($this->gauche!=null)
		 	$ret1=$this->gauche->profondeur();
		if($this->droit!=null)
			$ret2=$this->droit->profondeur();
			
		if($ret1>$ret2)
		{
			return $ret1 + 1;
		}else{
			return $ret2 + 1;
		}
		
	}
	
	function ajouterParHauteurGD($H,$donnee)
	{
		if($H<1) return false;
		if($H==1)
		{
			if($this->data==null)
			{
				$this->setData($donnee);
				return true;
			}
		}else{
			if($this->gauche!=null)
				$ret= $this->gauche->ajouterParHauteurGD($H-1,$donnee);
			if($ret) return $ret;
			if($this->droit!=null)
				return $this->droit->ajouterParHauteurGD($H-1,$donnee);
			return false;
		}
	}
	
	function ajouterParHauteurDG($H,$donnee)
	{
		if($H<1) return false;
		if($H==1)
		{
			if($this->data==null)
			{
				$this->setData($donnee);
				return true;
			}
		}else{
			if($this->droit!=null)
				$ret= $this->droit->ajouterParHauteurDG($H-1,$donnee);
			if($ret) return $ret;
			if($this->gauche!=null)
				return $this->gauche->ajouterParHauteurDG($H-1,$donnee);
			return false;
		}
	}
	
	function ajouterFeuilleDG($donnee)
	{
		if($this->gauche==null && $this->droit==null && $this->data==null)//C'est une feuille vide
		{
			$this->setData($donnee);
			return true;
		}else{
			if($this->droit!=null)
			{
				 $rep=$this->droit->ajouterFeuilleDG($donnee);
				 if($rep) return true;
			}
			if($this->gauche!=null)
			{
				return $this->gauche->ajouterFeuilleDG($donnee);
			}
			return false;
		}
	}
	function ajouterFeuilleGD($donnee)
	{
		if($this->gauche==null && $this->droit==null && $this->data==null)//C'est une feuille vide
		{
			$this->setData($donnee);
			return true;
		}else{
			if($this->gauche!=null)
			{
				 $rep=$this->gauche->ajouterFeuilleGD($donnee);
				 if($rep) return true;
			}
			if($this->droit!=null)
			{
				return $this->droit->ajouterFeuilleGD($donnee);
			}
			return false;
		}
	}
	
	function listeDerFeuilles(&$L)
	{
		/*Cette fonction renvoie la liste des feuilles du dernier niveau */
		if($this->gauche==null && $this->droit==null)
		{
			$L[0]=$this;
			return 0;
		}
		
		if($this->gauche!=null && $this->droit==null)
			return $this->gauche->listeDerFeuilles($L) +1;
		
		if($this->gauche==null && $this->droit!=null)
			return $this->droit->listeDerFeuilles($L) +1;
		
		$nivG = $this->gauche->listeDerFeuilles($L1);
		$nivD = $this->droit->listeDerFeuilles($L2);
		
		if($nivG==$nivD)
		{
			$L=array_merge($L1,$L2);
			return $nivG +1;
		}else{
			if($nivG>$nivD)
			{
				$L=$L1; 
				return $nivG + 1;
			}else{
				$L=$L2;
				return $nivD +1;
			}
		}
		
	}
	
	function convertirEnTableau($hauteur=0) 
	{
		$tmp=array();
		
		if($this->gauche==null && $this->droit==null) {
			$tmp[$hauteur][0]=& $this;
			return $tmp;
		}
		if($this->gauche!=null)
		{
			$tmp= $this->gauche->convertirEnTableau($hauteur+1);
		}
		if($this->droit!=null)
		{
			
			$tmp2 = $this->droit->convertirEnTableau($hauteur+1);
			$nb=(count($tmp)>count($tmp2))?count($tmp):count($tmp2);
			for($i=$hauteur+1;$i<($nb + $hauteur + 1) ;$i++)
				$tmp[$i] = array_merge((array)$tmp[$i],(array)$tmp2[$i]);
		}
		$tmp[$hauteur][0]=$this;
		return $tmp;
	}
	
	function ajouterNoeud($nb)
        {
            if($nb<2) return;
            $g=new CTree();
            $d=new CTree();
            $this->setGauche($g);
            $this->setDroit($d);
            $this->gauche->ajouterNoeud(intval($nb/2));
            $this->droit->ajouterNoeud(intval($nb/2));

        }
	
}

?>