<?php
/**
 * Joom!Fish - Multi Lingual extention and translation manager for Joomla!
 * Copyright (C) 2003-2008 Think Network GmbH, Munich
 *
 * All rights reserved.  The Joom!Fish project is a set of extentions for
 * the content management system Joomla!. It enables Joomla!
 * to manage multi lingual sites especially in all dynamic information
 * which are stored in the database.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * The "GNU General Public License" (GPL) is available at
 * http: *www.gnu.org/copyleft/gpl.html
 * -----------------------------------------------------------------------------
 * $Id: mod_jflanguageselection.php 610 2007-08-30 11:11:58Z geraint $
 *
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

// Prevent redifinition of class, when module is used in two separate locations
if( !defined( 'JFMODULE_CLASS' ) ) {
	define( 'JFMODULE_CLASS', true );

	class JFModuleHTML {

		function makeOption( $value, $text='', $style='') {
			$obj = new stdClass;
			$obj->value = $value;
			$obj->text = $text;
			$obj->style = $style;
			return $obj;
		}

		/**
	* Generates an HTML select list
	* @param array An array of objects
	* @param string The value of the HTML name attribute
	* @param string Additional HTML attributes for the <select> tag
	* @param string The name of the object variable for the option value
	* @param string The name of the object variable for the option text
	* @param mixed The key that is selected
	* @returns string HTML for the select list
	*/
		function selectList( &$arr, $tag_name, $tag_attribs, $key, $text, $selected=NULL ) {
			// check if array
			if ( is_array( $arr ) ) {
				reset( $arr );
			}

			$html 	= "\n<select name=\"$tag_name\" $tag_attribs>";
			$count 	= count( $arr );

			for ($i=0, $n=$count; $i < $n; $i++ ) {
				$k = $arr[$i]->$key;
				$t = $arr[$i]->$text;
				$id = ( isset($arr[$i]->id) ? @$arr[$i]->id : null);

				$extra = ' '.$arr[$i]->style." ";
				$extra .= $id ? " id=\"" . $arr[$i]->id . "\"" : '';
				if (is_array( $selected )) {
					foreach ($selected as $obj) {
						$k2 = $obj->$key;
						if ($k == $k2) {
							$extra .= " selected=\"selected\"";
							break;
						}
					}
				} else {
					$extra .= ($k == $selected ? " selected=\"selected\"" : '');
				}
				$html .= "\n\t<option value=\"".$k."\"$extra >" . $t . "</option>";
			}
			$html .= "\n</select>\n";

			return $html;
		}

		/**
	 * internal function to generate a new href link
	 * @param	string	shortcode of the wanted language
	 * @return	string	new href string
	 */
		function _createHRef( $code ) {
			
			$app	= &JFactory::getApplication();
			$router = &$app->getRouter();
			$vars = $router->getVars();

			$href= "index.php";
			$hrefVars = '';

			// set lang to correct value
			$vars['lang']=$code;
						
			foreach ($vars as $k=>$v) {
				if( $hrefVars != "" ) {
						$hrefVars .= "&";
				}
				$hrefVars .= $k.'='.$v;
			}

			// Add the existing variables
			if( $hrefVars != "" ) {
				$href .= '?' .$hrefVars;
			}

			// Treat change of language specially because of problems if menu alias is translated 
			$registry =& JFactory::getConfig();
			$language = $registry->getValue("joomfish.language",null);
			$jfLang = $language->getLanguageCode();			

			if ( !is_null($code) && $code != $jfLang){
				$registry =& JFactory::getConfig();
				$sefLang = TableJFLanguage::createByShortcode($code, false);				
				$registry->setValue("joomfish.sef_lang", $sefLang->code);				

				$url = JRoute::_( $href );
				$registry->setValue("joomfish.sef_lang", false);
				return $url;

				/*
				$menu  =& JSite::getMenu(true);
				if (version_compare(phpversion(), '5.0') >= 0) {
					$keepmenu = clone($menu);
				}
				else {
					$keepmenu = $menu;
				}
				$menu = new JMenuSite();
				$url = JRoute::_( $href );
				$registry->setValue("joomfish.sef_lang", false);
				$menu = $keepmenu;
				return $url;
				*/
			}			

			return JRoute::_( $href );
		}
	}
}
