<?php
/**
 * Joom!Fish - Multi Lingual extention and translation manager for Joomla!
 * Copyright (C) 2003-2008 Think Network GmbH, Munich
 *
 * All rights reserved.  The Joom!Fish project is a set of extentions for
 * the content management system Joomla!. It enables Joomla!
 * to manage multi lingual sites especially in all dynamic information
 * which are stored in the database.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * The "GNU General Public License" (GPL) is available at
 * http: *www.gnu.org/copyleft/gpl.html
 * -----------------------------------------------------------------------------
 * $Id: mod_jflanguageselection.php 610 2007-08-30 11:11:58Z geraint $
 *
*/

/**
* @package joomfish
* @subpackage mod_jflanguageselection
* @copyright 2003-2007 Think Network GmbH
* @license http://www.gnu.org/copyleft/gpl.html GNU General Public License
* @version 1.7 - $Id: mod_jflanguageselection.php 610 2007-08-30 11:11:58Z geraint $
* @author Geraint Edwards
**/

// no direct access
defined('_JEXEC') or die('Restricted access');

// Include the helper functions only once
require_once (dirname(__FILE__).DS.'helper.php');

$type 		= trim( $params->get( 'type', 'dropdown' ));
$layout = JModuleHelper::getLayoutPath('mod_jflanguageselection',$type);

$inc_jf_css	= intval( $params->get( 'inc_jf_css', 1 ));
$cache 		= intval( $params->get( 'cache', 0 ) );
$type 		= trim( $params->get( 'type', 'dropdown' ));
$show_active= intval( $params->get( 'show_active', 1 ) );
$spacer		= trim( $params->get( 'spacer', '&nbsp;' ) );

jimport('joomla.filesystem.file');

global $_JOOMFISH_MANAGER;
global $iso_client_lang;

$langActive = $_JOOMFISH_MANAGER->getActiveLanguages();

// setup Joomfish plugins
$dispatcher	   =& JDispatcher::getInstance();
JPluginHelper::importPlugin('joomfish');
$dispatcher->trigger('onAfterModuleActiveLanguages', array (&$langActive));
	
$outString = '';
if( !isset( $langActive ) || count($langActive)==0) {
	// No active languages => nothing to show :-(
	return;
}

// check for unauthorised access to inactive language
$curLanguage = JFactory::getLanguage();
if (!array_key_exists($curLanguage->getTag(),$langActive)){
	reset($langActive);
	$lang = current($langActive);
	global $mainframe;
	//$mainframe->redirect(JRoute::_("index.php?lang=".$lang->iso));
	die($curLanguage->getTag());
}

require($layout);
?>
<!--Joom!fish <?php echo JoomFishManager::getVersion();?>-->
<!-- &copy; 2003-2008 Think Network, released under the GPL. -->
<!-- More information: at http://www.joomfish.net -->